
#ifndef MP_WSA_WRAPPER_H_
#define MP_WSA_WRAPPER_H_

#ifdef _WIN32
#include <Winsock2.h>
#include <stdio.h>
#pragma comment(lib, "Ws2_32.lib")
#endif // _WIN32

#include "stdio_synchronizer.hpp"

namespace multiplatform {

// This class will act as a wrapper to describe "WSAStartup()/WSACleanup()" coding the as same as Windows way on Linux.
class wsa_wrapper {
public:
#ifdef _WIN32
  wsa_wrapper(void): m_running(false){
    WORD version = MAKEWORD(2, 2);
    WSADATA data;
    if(WSAStartup(version, &data) != 0){ _error_throw("WSAStartup() failed."); }
    m_running = true;
  }
  ~wsa_wrapper(void){
    if(m_running){ WSACleanup(); }
  }
#else // _WIN32
  wsa_wrapper(void): m_running(true){ }
  ~wsa_wrapper(void){ }
#endif // _WIN32
  wsa_wrapper(const wsa_wrapper&) = delete;             // Removed copy constructor.
  wsa_wrapper& operator=(const wsa_wrapper&) = delete;  // Removed assignment operator.

  bool is_running(void) const{ return m_running; }

private:
  bool m_running;
};

} // namespace multiplatform

#endif // MP_WSA_WRAPPER_H_

