// recognizer.h

#ifndef PRINT_LICENSE_H_
#define PRINT_LICENSE_H_

#include "mp/stdio_synchronizer.hpp"

inline void print_hark_license()
{
  const char* hark_license =
    "\n"
    "                        HARK LICENSE AGREEMENT\n"
    "                       version 1.0, April 2008\n"
    "                http://winnie.kuis.kyoto-u.ac.jp/HARK/\n"
    "The Kyoto University and (\"Kyoto University\") and Honda Research\n"
    "Institute Japan Co.,Ltd. (\"HRI-JP\") collaboratively developed a\n"
    "certain computer program for voice audio system named \"HARK\", and the\n"
    "Kyoto University and Honda Motor Co., Ltd., a due ultimate assigner of\n"
    "all titles to the intellectual properties created by HRI-JP regarding\n"
    "HARK (individually or collectively \"Licensor\") hereby release and make\n"
    "publicly available the source code of HARK to free software\n"
    "development community under the terms and conditions of this license.\n"
    "PLEASE READ THIS AGREEMENT CAREFULLY AND COMPLETELLY BEFORE\n"
    "DOWNLOADING HARK. BY INSTALLING, USING OR DISTRIBUTING HARK, YOU\n"
    "ACCEPT ALL OF THE TERMS OF THIS AGREEMENT.\n"
    "Section 1.Definitions\n"
    "1.1 \"License\" means the terms and conditions for use, reproduction,\n"
    "    distribution and modification of the Software as specified herein.\n"
    "1.2 \"Software\" means the Original Work and the Derivative Work, the\n"
    "    combination of any portion of the Original Work and the Derivative\n"
    "    Work, or any respective portions thereof.\n"
    "1.3 \"Original Work\" means any works named \"HARK\" whether in source or\n"
    "    object code, made available hereunder including any update or\n"
    "    upgrade thereof, sample files and the related documentations.\n"
    "1.4 \"Derivative Work\" means any addition to, deletion from or change\n"
    "    to the substance or the structure of the Original Work, any new\n"
    "    work whether in source or object code which contains any part of\n"
    "    the Original Work including any revisions and modification of the\n"
    "    Original Work, or which is based on or derived from the Original\n"
    "    Work. For the purposes of the License, the Derivative Work shall\n"
    "    not include any works which works independently from and remains\n"
    "    separable from, or merely link to the interface of, the Original\n"
    "    Work.\n"
    "1.5 \"Contribution\" means any Derivative Work created and published as\n"
    "    a component(s) of HARK pursuant to the Section 2.1(3)(i) or any\n"
    "    contribution to any creation of such Derivative Work.\n"
    "1.6 \"Contributor\" means any individual and legal entity that creates\n"
    "    or makes the Contribution.\n"
    "1.7 \"You\" or \"Your\" means an individual or legal entity excising\n"
    "    rights under the License.\n"
    "Section 2. License Grant\n"
    "2.1 Subject to the terms and conditions of the License, the Licensor\n"
    "    and each Contributor hereby grant to you a world-wide,\n"
    "    non-exclusive, royalty free, non-assignable, non-transferable\n"
    "    license to reproduce, use, modify the Software and/or distribute\n"
    "    the Derivative Works in object or source code only for the purpose\n"
    "    of research, development, education and/or academic purpose (\"\n"
    "    Purpose\") provided that:\n"
    "(1) You reproduce in all copies of the Software that you make or\n"
    "    create, or in the Derivative Work that You create (\"Your\n"
    "    Derivative Work\") and distribute in accordance the License the\n"
    "    copyright, trademark and other proprietary notices as they appear\n"
    "    in the Original Work and any other notices and disclaimers\n"
    "    attached to the Software and keep intact all notices in the\n"
    "    Software that refer to the License and absence of any warranty;\n"
    "(2) You include a copy of the License with every copy of Your\n"
    "    Derivative Work which You distribute;\n"
    "(3) In case that You distribute Your Derivative Work to any user, you\n"
    "    (i) publish Your Derivative Work and all of the source code\n"
    "    information thereof where You and the Licenser agreed separately,\n"
    "    or (ii) provide the Licensor with Your Derivative Work and all of\n"
    "    the source code information thereof;\n"
    "(4) When You publish any research results that You make using the\n"
    "    Software including Your Derivative Work in any manner whatsoever\n"
    "    including in paper, presentation or demonstration, You clearly\n"
    "    mention in the publication the fact that You use the Software\n"
    "    granted hereunder in the process of Your research or to achieve\n"
    "    such results.\n"
    "2.2 You may add Your own copyright, trademark and other proprietary\n"
    "    notices to Your Derivative Work and may provide additional terms\n"
    "    and conditions for use, reproduction, distribution and\n"
    "    modification of Your Derivative Work, provided that You are not\n"
    "    authorized to impose any terms or conditions which may conflict\n"
    "    with or prevail those of the License.\n"
    "2.3 In case that You desire to use the Software other than the\n"
    "    purposes authorized hereunder including for commercial, economical\n"
    "    or otherwise business purpose You; (i) first inform of the\n"
    "    Licensor Your intention of such commercial use, and (ii) enter\n"
    "    into a license agreement separately of which terms and conditions\n"
    "    will be negotiated and agreed by You and the Licensor.\n"
    "Section 3. Support\n"
    "You may request and ask for any supports, including bug fixes, updates\n"
    "or upgrades of the Software, or any other enhancement in using the\n"
    "Software or regarding the License (\"Support\") at the web-site of HARK\n"
    "(http://winnie.kuis.kyoto-u.ac.jp/HARK/) or sending an E-mail to:\n"
    "\"hark-support@kuis.kyoto-u.ac.jp\". The Licensor may, at its own\n"
    "discretion, provide You with any Support therefor directly or at HARK\n"
    "web-site. In no case, the Licensor is liable, responsible or otherwise\n"
    "obligated to; (i) reply to You, or provide You with the Support, or\n"
    "(ii) warrant the Support is valid, correct, effective or otherwise\n"
    "serves the specific purpose intended by You.\n"
    "Section 4. Disclaimer of Warranty\n"
    "The Licensor and each Contributor provide the Software on an \"AS IS\n"
    "BASIS\", WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,EITHER EXPRESS OR\n"
    "IMPLIED, INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES AND OR\n"
    "CONDITIONS OF TITLE, FREE OF DEFECTS, NON-INFRINGEMENT,\n"
    "MERCHANTABILILY, OR FITNESS FOR A PATICULAR PURPOSE. You are sorely\n"
    "responsible for determining the appropriateness of using the Software\n"
    "or distributing Your Derivative Work.\n"
    "Section 5. Trademarks and Logos\n"
    "The License does not grant any right or license to use the trademarks,\n"
    "trade names, logos, and service marks or product names of the Licensor\n"
    "except as required to describe the origin of the Software in the\n"
    "Section 2.1.\n"
    "Section 6. Patents\n"
    "In case that any patent(s) is used in the Software or Your use of the\n"
    "Software may constitute any use of the Licensor or any Contributor's\n"
    "patent(s), the License does not grant any right or license to use the\n"
    "patent other than using the Software hereunder.\n"
    "Section 7. Limited Warranty \n"
    "In no event and under no legal theory, whether in tort or contract,\n"
    "shall the Licensor and any Contributor be liable to You for damages,\n"
    "including any direct, indirect, special, incidental, or consequential\n"
    "damages of any character arising from or as a result of the License or\n"
    "out of the use or inability to use the Software including but not\n"
    "limited to damages for loss of goodwill, work stoppage, loss of data,\n"
    "computer failure or malfunction or any or all other damages or losses\n"
    "even if the Licensor or such Contributor has been advised of the\n"
    "possibility of such damages.\n"
    "Section 8. Termination\n"
    "8.1 The Licensor may terminate the License granted to You upon notice\n"
    "    for Your breach of any terms and conditions of the License.\n"
    "8.2 The Licensor may terminate the License granted to You at its sole\n"
    "    discretion with thirty (30) days prior notice for any reason\n"
    "    whatsoever.\n"
    "8.3. In case of the termination pursuant to this Section 8, You\n"
    "     immediately cease any further use, reproduction and modification\n"
    "     of the Software, sublicensing and distribution of the Derivative\n"
    "     Work, and destroy or delete the Software in your procession or\n"
    "     control. All licenses for the Derivative Work which has been\n"
    "     properly granted prior to the termination shall survive the\n"
    "     termination of the License for three (3) years.\n"
    "8.4 Notwithstanding the provision of Section 8.3, in case that You\n"
    "    desire to continue use of Your Derivative Work after the\n"
    "    termination of the License, You obtain a prior written consent of\n"
    "    the Licensor for such use under certain terms and conditions\n"
    "    mutually agreed separately by You and the Licensor.\n"
    "Section 9. Miscellaneous\n"
    "9.1 The License will not be construed as creating an agency,\n"
    "    partnership, joint venture or any other form of legal association\n"
    "    between You and the Licensor. You will not represent to the\n"
    "    contrary, whether expressly, by implications or otherwise.\n"
    "9.2 Nothing in the License will impair the Licensor's right to\n"
    "    acquire, license, develop, make someone develop for its behalf,\n"
    "    publish or distribute technologies or products that perform the\n"
    "    same or similar functions as, or otherwise compete with, YOUR\n"
    "    Derivative Work, or technologies or products that You may create,\n"
    "    develop, produce, publish or distribute.\n"
    "9.3 Should for any reason any provisions of the License or portion\n"
    "    thereof, be found to be in valid or unenforceable in any\n"
    "    jurisdiction in which the License is being performed, the reminder\n"
    "    of the License will be valid and enforceable and the parties will\n"
    "    use good faith to negotiate a substitute, valid, and enforceable\n"
    "    provision which most nearly effects the parties' intent in\n"
    "    entering into the License.\n"
    "9.4 This Agreement will be governed by and construed in accordance\n"
    "    with the laws of Japan without reference to conflicts of laws\n"
    "    principles.\n"
    "9.5 This Agreement will be executed in the English language even\n"
    "    though there is any translation thereof.\n"
    "9.4 This Agreement will be governed by and construed in accordance\n"
    "    with the laws of Japan without reference to conflicts of laws\n"
    "    principles.\n"
    "9.5 This Agreement will be executed in the English language even\n"
    "    though there is any translation thereof.\n"
    "                         END OF THE AGREEMENT\n"
    "\n";
  _info_print(hark_license);
}

inline void print_apache_license()
{
  const char* apache_license =
    "\n"
    "                                 Apache License\n"
    "                           Version 2.0, January 2004\n"
    "                        http://www.apache.org/licenses/\n"
    "\n"
    "   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n"
    "\n"
    "   1. Definitions.\n"
    "\n"
    "      \"License\" shall mean the terms and conditions for use, reproduction,\n"
    "      and distribution as defined by Sections 1 through 9 of this document.\n"
    "\n"
    "      \"Licensor\" shall mean the copyright owner or entity authorized by\n"
    "      the copyright owner that is granting the License.\n"
    "\n"
    "      \"Legal Entity\" shall mean the union of the acting entity and all\n"
    "      other entities that control, are controlled by, or are under common\n"
    "      control with that entity. For the purposes of this definition,\n"
    "      \"control\" means (i) the power, direct or indirect, to cause the\n"
    "      direction or management of such entity, whether by contract or\n"
    "      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n"
    "      outstanding shares, or (iii) beneficial ownership of such entity.\n"
    "\n"
    "      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n"
    "      exercising permissions granted by this License.\n"
    "\n"
    "      \"Source\" form shall mean the preferred form for making modifications,\n"
    "      including but not limited to software source code, documentation\n"
    "      source, and configuration files.\n"
    "\n"
    "      \"Object\" form shall mean any form resulting from mechanical\n"
    "      transformation or translation of a Source form, including but\n"
    "      not limited to compiled object code, generated documentation,\n"
    "      and conversions to other media types.\n"
    "\n"
    "      \"Work\" shall mean the work of authorship, whether in Source or\n"
    "      Object form, made available under the License, as indicated by a\n"
    "      copyright notice that is included in or attached to the work\n"
    "      (an example is provided in the Appendix below).\n"
    "\n"
    "      \"Derivative Works\" shall mean any work, whether in Source or Object\n"
    "      form, that is based on (or derived from) the Work and for which the\n"
    "      editorial revisions, annotations, elaborations, or other modifications\n"
    "      represent, as a whole, an original work of authorship. For the purposes\n"
    "      of this License, Derivative Works shall not include works that remain\n"
    "      separable from, or merely link (or bind by name) to the interfaces of,\n"
    "      the Work and Derivative Works thereof.\n"
    "\n"
    "      \"Contribution\" shall mean any work of authorship, including\n"
    "      the original version of the Work and any modifications or additions\n"
    "      to that Work or Derivative Works thereof, that is intentionally\n"
    "      submitted to Licensor for inclusion in the Work by the copyright owner\n"
    "      or by an individual or Legal Entity authorized to submit on behalf of\n"
    "      the copyright owner. For the purposes of this definition, \"submitted\"\n"
    "      means any form of electronic, verbal, or written communication sent\n"
    "      to the Licensor or its representatives, including but not limited to\n"
    "      communication on electronic mailing lists, source code control systems,\n"
    "      and issue tracking systems that are managed by, or on behalf of, the\n"
    "      Licensor for the purpose of discussing and improving the Work, but\n"
    "      excluding communication that is conspicuously marked or otherwise\n"
    "      designated in writing by the copyright owner as \"Not a Contribution.\"\n"
    "\n"
    "      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n"
    "      on behalf of whom a Contribution has been received by Licensor and\n"
    "      subsequently incorporated within the Work.\n"
    "\n"
    "   2. Grant of Copyright License. Subject to the terms and conditions of\n"
    "      this License, each Contributor hereby grants to You a perpetual,\n"
    "      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n"
    "      copyright license to reproduce, prepare Derivative Works of,\n"
    "      publicly display, publicly perform, sublicense, and distribute the\n"
    "      Work and such Derivative Works in Source or Object form.\n"
    "\n"
    "   3. Grant of Patent License. Subject to the terms and conditions of\n"
    "      this License, each Contributor hereby grants to You a perpetual,\n"
    "      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n"
    "      (except as stated in this section) patent license to make, have made,\n"
    "      use, offer to sell, sell, import, and otherwise transfer the Work,\n"
    "      where such license applies only to those patent claims licensable\n"
    "      by such Contributor that are necessarily infringed by their\n"
    "      Contribution(s) alone or by combination of their Contribution(s)\n"
    "      with the Work to which such Contribution(s) was submitted. If You\n"
    "      institute patent litigation against any entity (including a\n"
    "      cross-claim or counterclaim in a lawsuit) alleging that the Work\n"
    "      or a Contribution incorporated within the Work constitutes direct\n"
    "      or contributory patent infringement, then any patent licenses\n"
    "      granted to You under this License for that Work shall terminate\n"
    "      as of the date such litigation is filed.\n"
    "\n"
    "   4. Redistribution. You may reproduce and distribute copies of the\n"
    "      Work or Derivative Works thereof in any medium, with or without\n"
    "      modifications, and in Source or Object form, provided that You\n"
    "      meet the following conditions:\n"
    "\n"
    "      (a) You must give any other recipients of the Work or\n"
    "          Derivative Works a copy of this License; and\n"
    "\n"
    "      (b) You must cause any modified files to carry prominent notices\n"
    "          stating that You changed the files; and\n"
    "\n"
    "      (c) You must retain, in the Source form of any Derivative Works\n"
    "          that You distribute, all copyright, patent, trademark, and\n"
    "          attribution notices from the Source form of the Work,\n"
    "          excluding those notices that do not pertain to any part of\n"
    "          the Derivative Works; and\n"
    "\n"
    "      (d) If the Work includes a \"NOTICE\" text file as part of its\n"
    "          distribution, then any Derivative Works that You distribute must\n"
    "          include a readable copy of the attribution notices contained\n"
    "          within such NOTICE file, excluding those notices that do not\n"
    "          pertain to any part of the Derivative Works, in at least one\n"
    "          of the following places: within a NOTICE text file distributed\n"
    "          as part of the Derivative Works; within the Source form or\n"
    "          documentation, if provided along with the Derivative Works; or,\n"
    "          within a display generated by the Derivative Works, if and\n"
    "          wherever such third-party notices normally appear. The contents\n"
    "          of the NOTICE file are for informational purposes only and\n"
    "          do not modify the License. You may add Your own attribution\n"
    "          notices within Derivative Works that You distribute, alongside\n"
    "          or as an addendum to the NOTICE text from the Work, provided\n"
    "          that such additional attribution notices cannot be construed\n"
    "          as modifying the License.\n"
    "\n"
    "      You may add Your own copyright statement to Your modifications and\n"
    "      may provide additional or different license terms and conditions\n"
    "      for use, reproduction, or distribution of Your modifications, or\n"
    "      for any such Derivative Works as a whole, provided Your use,\n"
    "      reproduction, and distribution of the Work otherwise complies with\n"
    "      the conditions stated in this License.\n"
    "\n"
    "   5. Submission of Contributions. Unless You explicitly state otherwise,\n"
    "      any Contribution intentionally submitted for inclusion in the Work\n"
    "      by You to the Licensor shall be under the terms and conditions of\n"
    "      this License, without any additional terms or conditions.\n"
    "      Notwithstanding the above, nothing herein shall supersede or modify\n"
    "      the terms of any separate license agreement you may have executed\n"
    "      with Licensor regarding such Contributions.\n"
    "\n"
    "   6. Trademarks. This License does not grant permission to use the trade\n"
    "      names, trademarks, service marks, or product names of the Licensor,\n"
    "      except as required for reasonable and customary use in describing the\n"
    "      origin of the Work and reproducing the content of the NOTICE file.\n"
    "\n"
    "   7. Disclaimer of Warranty. Unless required by applicable law or\n"
    "      agreed to in writing, Licensor provides the Work (and each\n"
    "      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n"
    "      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n"
    "      implied, including, without limitation, any warranties or conditions\n"
    "      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n"
    "      PARTICULAR PURPOSE. You are solely responsible for determining the\n"
    "      appropriateness of using or redistributing the Work and assume any\n"
    "      risks associated with Your exercise of permissions under this License.\n"
    "\n"
    "   8. Limitation of Liability. In no event and under no legal theory,\n"
    "      whether in tort (including negligence), contract, or otherwise,\n"
    "      unless required by applicable law (such as deliberate and grossly\n"
    "      negligent acts) or agreed to in writing, shall any Contributor be\n"
    "      liable to You for damages, including any direct, indirect, special,\n"
    "      incidental, or consequential damages of any character arising as a\n"
    "      result of this License or out of the use or inability to use the\n"
    "      Work (including but not limited to damages for loss of goodwill,\n"
    "      work stoppage, computer failure or malfunction, or any and all\n"
    "      other commercial damages or losses), even if such Contributor\n"
    "      has been advised of the possibility of such damages.\n"
    "\n"
    "   9. Accepting Warranty or Additional Liability. While redistributing\n"
    "      the Work or Derivative Works thereof, You may choose to offer,\n"
    "      and charge a fee for, acceptance of support, warranty, indemnity,\n"
    "      or other liability obligations and/or rights consistent with this\n"
    "      License. However, in accepting such obligations, You may act only\n"
    "      on Your own behalf and on Your sole responsibility, not on behalf\n"
    "      of any other Contributor, and only if You agree to indemnify,\n"
    "      defend, and hold each Contributor harmless for any liability\n"
    "      incurred by, or claims asserted against, such Contributor by reason\n"
    "      of your accepting any such warranty or additional liability.\n"
    "\n"
    "   END OF TERMS AND CONDITIONS\n"
    "\n"
    "   APPENDIX: How to apply the Apache License to your work.\n"
    "\n"
    "      To apply the Apache License to your work, attach the following\n"
    "      boilerplate notice, with the fields enclosed by brackets \"[]\"\n"
    "      replaced with your own identifying information. (Don't include\n"
    "      the brackets!)  The text should be enclosed in the appropriate\n"
    "      comment syntax for the file format. We also recommend that a\n"
    "      file or class name and description of purpose be included on the\n"
    "      same \"printed page\" as the copyright notice for easier\n"
    "      identification within third-party archives.\n"
    "\n"
    "   Copyright [yyyy] [name of copyright owner]\n"
    "\n"
    "   Licensed under the Apache License, Version 2.0 (the \"License\");\n"
    "   you may not use this file except in compliance with the License.\n"
    "   You may obtain a copy of the License at\n"
    "\n"
    "       http://www.apache.org/licenses/LICENSE-2.0\n"
    "\n"
    "   Unless required by applicable law or agreed to in writing, software\n"
    "   distributed under the License is distributed on an \"AS IS\" BASIS,\n"
    "   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n"
    "   See the License for the specific language governing permissions and\n"
    "   limitations under the License.\n"
    "\n";
  _info_print(apache_license);
}

inline void print_mit_license()
{
  const char* mit_license =
    "\n"
    "Copyright (c) <year> <copyright holders>\n"
    "\n"
    "Permission is hereby granted, free of charge, to any person obtaining a copy\n"
    "of this software and associated documentation files (the \"Software\"), to deal\n"
    "in the Software without restriction, including without limitation the rights\n"
    "to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
    "copies of the Software, and to permit persons to whom the Software is\n"
    "furnished to do so, subject to the following conditions:\n"
    "\n"
    "The above copyright notice and this permission notice shall be included in all\n"
    "copies or substantial portions of the Software.\n"
    "\n"
    "THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
    "IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
    "FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
    "AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
    "LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
    "OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
    "SOFTWARE.\n"
    "\n";
  _info_print(mit_license);
}

inline void print_bsd_4clause_license()
{
  const char* bsd_4clause_license =
    "\n"
    "Copyright (c) <year>, <copyright holder>\n"
    "All rights reserved.\n"
    "\n"
    "Redistribution and use in source and binary forms, with or without\n"
    "modification, are permitted provided that the following conditions are met:\n"
    "1. Redistributions of source code must retain the above copyright\n"
    "   notice, this list of conditions and the following disclaimer.\n"
    "2. Redistributions in binary form must reproduce the above copyright\n"
    "   notice, this list of conditions and the following disclaimer in the\n"
    "   documentation and/or other materials provided with the distribution.\n"
    "3. All advertising materials mentioning features or use of this software\n"
    "   must display the following acknowledgement:\n"
    "   This product includes software developed by the <organization>.\n"
    "4. Neither the name of the <organization> nor the\n"
    "   names of its contributors may be used to endorse or promote products\n"
    "   derived from this software without specific prior written permission.\n"
    "\n"
    "THIS SOFTWARE IS PROVIDED BY <COPYRIGHT HOLDER> ''AS IS'' AND ANY\n"
    "EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED\n"
    "WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE\n"
    "DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY\n"
    "DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES\n"
    "(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;\n"
    "LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND\n"
    "ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\n"
    "(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS\n"
    "SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n"
    "\n";
  _info_print(bsd_4clause_license);
}

inline void print_bsd_3clause_license()
{
  const char* bsd_3clause_license =
    "\n"
    "Copyright (c) <year>, <copyright holder>\n"
    "All rights reserved.\n"
    "\n"
    "Redistribution and use in source and binary forms, with or without\n"
    "modification, are permitted provided that the following conditions are met:\n"
    "    * Redistributions of source code must retain the above copyright\n"
    "      notice, this list of conditions and the following disclaimer.\n"
    "    * Redistributions in binary form must reproduce the above copyright\n"
    "      notice, this list of conditions and the following disclaimer in the\n"
    "      documentation and/or other materials provided with the distribution.\n"
    "    * Neither the name of the <organization> nor the\n"
    "      names of its contributors may be used to endorse or promote products\n"
    "      derived from this software without specific prior written permission.\n"
    "\n"
    "THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"AS IS\" AND\n"
    "ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED\n"
    "WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE\n"
    "DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY\n"
    "DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES\n"
    "(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;\n"
    "LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND\n"
    "ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\n"
    "(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS\n"
    "SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n"
    "\n";
  _info_print(bsd_3clause_license);
}

inline void print_bsd_2clause_license()
{
  const char* bsd_2clause_license =
    "\n"
    "Copyright (c) <year>, <copyright holder>\n"
    "All rights reserved.\n"
    "\n"
    "Redistribution and use in source and binary forms, with or without\n"
    "modification, are permitted provided that the following conditions are met:\n"
    "\n"
    "1. Redistributions of source code must retain the above copyright notice, this\n"
    "   list of conditions and the following disclaimer.\n"
    "2. Redistributions in binary form must reproduce the above copyright notice,\n"
    "   this list of conditions and the following disclaimer in the documentation\n"
    "   and/or other materials provided with the distribution.\n"
    "\n"
    "THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"AS IS\" AND\n"
    "ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED\n"
    "WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE\n"
    "DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR\n"
    "ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES\n"
    "(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;\n"
    "LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND\n"
    "ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\n"
    "(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS\n"
    "SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n"
    "\n"
    "The views and conclusions contained in the software and documentation are those\n"
    "of the authors and should not be interpreted as representing official policies,\n"
    "either expressed or implied, of the <project name> project.\n"
    "\n";
  _info_print(bsd_2clause_license);
}

inline void print_lgpl_2_1_license()
{
  const char* lgpl_2_1_license =
    "\n"
    "                  GNU LESSER GENERAL PUBLIC LICENSE\n"
    "                       Version 2.1, February 1999\n"
    "\n"
    " Copyright (C) 1991, 1999 Free Software Foundation, Inc.\n"
    " 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA\n"
    " Everyone is permitted to copy and distribute verbatim copies\n"
    " of this license document, but changing it is not allowed.\n"
    "\n"
    "[This is the first released version of the Lesser GPL.  It also counts\n"
    " as the successor of the GNU Library Public License, version 2, hence\n"
    " the version number 2.1.]\n"
    "\n"
    "                            Preamble\n"
    "\n"
    "  The licenses for most software are designed to take away your\n"
    "freedom to share and change it.  By contrast, the GNU General Public\n"
    "Licenses are intended to guarantee your freedom to share and change\n"
    "free software--to make sure the software is free for all its users.\n"
    "\n"
    "  This license, the Lesser General Public License, applies to some\n"
    "specially designated software packages--typically libraries--of the\n"
    "Free Software Foundation and other authors who decide to use it.  You\n"
    "can use it too, but we suggest you first think carefully about whether\n"
    "this license or the ordinary General Public License is the better\n"
    "strategy to use in any particular case, based on the explanations below.\n"
    "\n"
    "  When we speak of free software, we are referring to freedom of use,\n"
    "not price.  Our General Public Licenses are designed to make sure that\n"
    "you have the freedom to distribute copies of free software (and charge\n"
    "for this service if you wish); that you receive source code or can get\n"
    "it if you want it; that you can change the software and use pieces of\n"
    "it in new free programs; and that you are informed that you can do\n"
    "these things.\n"
    "\n"
    "  To protect your rights, we need to make restrictions that forbid\n"
    "distributors to deny you these rights or to ask you to surrender these\n"
    "rights.  These restrictions translate to certain responsibilities for\n"
    "you if you distribute copies of the library or if you modify it.\n"
    "\n"
    "  For example, if you distribute copies of the library, whether gratis\n"
    "or for a fee, you must give the recipients all the rights that we gave\n"
    "you.  You must make sure that they, too, receive or can get the source\n"
    "code.  If you link other code with the library, you must provide\n"
    "complete object files to the recipients, so that they can relink them\n"
    "with the library after making changes to the library and recompiling\n"
    "it.  And you must show them these terms so they know their rights.\n"
    "\n"
    "  We protect your rights with a two-step method: (1) we copyright the\n"
    "library, and (2) we offer you this license, which gives you legal\n"
    "permission to copy, distribute and/or modify the library.\n"
    "\n"
    "  To protect each distributor, we want to make it very clear that\n"
    "there is no warranty for the free library.  Also, if the library is\n"
    "modified by someone else and passed on, the recipients should know\n"
    "that what they have is not the original version, so that the original\n"
    "author's reputation will not be affected by problems that might be\n"
    "introduced by others.\n"
    "\n"
    "\n"
    "  Finally, software patents pose a constant threat to the existence of\n"
    "any free program.  We wish to make sure that a company cannot\n"
    "effectively restrict the users of a free program by obtaining a\n"
    "restrictive license from a patent holder.  Therefore, we insist that\n"
    "any patent license obtained for a version of the library must be\n"
    "consistent with the full freedom of use specified in this license.\n"
    "\n"
    "  Most GNU software, including some libraries, is covered by the\n"
    "ordinary GNU General Public License.  This license, the GNU Lesser\n"
    "General Public License, applies to certain designated libraries, and\n"
    "is quite different from the ordinary General Public License.  We use\n"
    "this license for certain libraries in order to permit linking those\n"
    "libraries into non-free programs.\n"
    "\n"
    "  When a program is linked with a library, whether statically or using\n"
    "a shared library, the combination of the two is legally speaking a\n"
    "combined work, a derivative of the original library.  The ordinary\n"
    "General Public License therefore permits such linking only if the\n"
    "entire combination fits its criteria of freedom.  The Lesser General\n"
    "Public License permits more lax criteria for linking other code with\n"
    "the library.\n"
    "\n"
    "  We call this license the \"Lesser\" General Public License because it\n"
    "does Less to protect the user's freedom than the ordinary General\n"
    "Public License.  It also provides other free software developers Less\n"
    "of an advantage over competing non-free programs.  These disadvantages\n"
    "are the reason we use the ordinary General Public License for many\n"
    "libraries.  However, the Lesser license provides advantages in certain\n"
    "special circumstances.\n"
    "\n"
    "  For example, on rare occasions, there may be a special need to\n"
    "encourage the widest possible use of a certain library, so that it becomes\n"
    "a de-facto standard.  To achieve this, non-free programs must be\n"
    "allowed to use the library.  A more frequent case is that a free\n"
    "library does the same job as widely used non-free libraries.  In this\n"
    "case, there is little to gain by limiting the free library to free\n"
    "software only, so we use the Lesser General Public License.\n"
    "\n"
    "  In other cases, permission to use a particular library in non-free\n"
    "programs enables a greater number of people to use a large body of\n"
    "free software.  For example, permission to use the GNU C Library in\n"
    "non-free programs enables many more people to use the whole GNU\n"
    "operating system, as well as its variant, the GNU/Linux operating\n"
    "system.\n"
    "\n"
    "  Although the Lesser General Public License is Less protective of the\n"
    "users' freedom, it does ensure that the user of a program that is\n"
    "linked with the Library has the freedom and the wherewithal to run\n"
    "that program using a modified version of the Library.\n"
    "\n"
    "  The precise terms and conditions for copying, distribution and\n"
    "modification follow.  Pay close attention to the difference between a\n"
    "\"work based on the library\" and a \"work that uses the library\".  The\n"
    "former contains code derived from the library, whereas the latter must\n"
    "be combined with the library in order to run.\n"
    "\n"
    "\n"
    "                  GNU LESSER GENERAL PUBLIC LICENSE\n"
    "   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION\n"
    "\n"
    "  0. This License Agreement applies to any software library or other\n"
    "program which contains a notice placed by the copyright holder or\n"
    "other authorized party saying it may be distributed under the terms of\n"
    "this Lesser General Public License (also called \"this License\").\n"
    "Each licensee is addressed as \"you\".\n"
    "\n"
    "  A \"library\" means a collection of software functions and/or data\n"
    "prepared so as to be conveniently linked with application programs\n"
    "(which use some of those functions and data) to form executables.\n"
    "\n"
    "  The \"Library\", below, refers to any such software library or work\n"
    "which has been distributed under these terms.  A \"work based on the\n"
    "Library\" means either the Library or any derivative work under\n"
    "copyright law: that is to say, a work containing the Library or a\n"
    "portion of it, either verbatim or with modifications and/or translated\n"
    "straightforwardly into another language.  (Hereinafter, translation is\n"
    "included without limitation in the term \"modification\".)\n"
    "\n"
    "  \"Source code\" for a work means the preferred form of the work for\n"
    "making modifications to it.  For a library, complete source code means\n"
    "all the source code for all modules it contains, plus any associated\n"
    "interface definition files, plus the scripts used to control compilation\n"
    "and installation of the library.\n"
    "\n"
    "  Activities other than copying, distribution and modification are not\n"
    "covered by this License; they are outside its scope.  The act of\n"
    "running a program using the Library is not restricted, and output from\n"
    "such a program is covered only if its contents constitute a work based\n"
    "on the Library (independent of the use of the Library in a tool for\n"
    "writing it).  Whether that is true depends on what the Library does\n"
    "and what the program that uses the Library does.\n"
    "\n"
    "  1. You may copy and distribute verbatim copies of the Library's\n"
    "complete source code as you receive it, in any medium, provided that\n"
    "you conspicuously and appropriately publish on each copy an\n"
    "appropriate copyright notice and disclaimer of warranty; keep intact\n"
    "all the notices that refer to this License and to the absence of any\n"
    "warranty; and distribute a copy of this License along with the\n"
    "Library.\n"
    "\n"
    "  You may charge a fee for the physical act of transferring a copy,\n"
    "and you may at your option offer warranty protection in exchange for a\n"
    "fee.\n"
    "\n"
    "\n"
    "  2. You may modify your copy or copies of the Library or any portion\n"
    "of it, thus forming a work based on the Library, and copy and\n"
    "distribute such modifications or work under the terms of Section 1\n"
    "above, provided that you also meet all of these conditions:\n"
    "\n"
    "    a) The modified work must itself be a software library.\n"
    "\n"
    "    b) You must cause the files modified to carry prominent notices\n"
    "    stating that you changed the files and the date of any change.\n"
    "\n"
    "    c) You must cause the whole of the work to be licensed at no\n"
    "    charge to all third parties under the terms of this License.\n"
    "\n"
    "    d) If a facility in the modified Library refers to a function or a\n"
    "    table of data to be supplied by an application program that uses\n"
    "    the facility, other than as an argument passed when the facility\n"
    "    is invoked, then you must make a good faith effort to ensure that,\n"
    "    in the event an application does not supply such function or\n"
    "    table, the facility still operates, and performs whatever part of\n"
    "    its purpose remains meaningful.\n"
    "\n"
    "    (For example, a function in a library to compute square roots has\n"
    "    a purpose that is entirely well-defined independent of the\n"
    "    application.  Therefore, Subsection 2d requires that any\n"
    "    application-supplied function or table used by this function must\n"
    "    be optional: if the application does not supply it, the square\n"
    "    root function must still compute square roots.)\n"
    "\n"
    "These requirements apply to the modified work as a whole.  If\n"
    "identifiable sections of that work are not derived from the Library,\n"
    "and can be reasonably considered independent and separate works in\n"
    "themselves, then this License, and its terms, do not apply to those\n"
    "sections when you distribute them as separate works.  But when you\n"
    "distribute the same sections as part of a whole which is a work based\n"
    "on the Library, the distribution of the whole must be on the terms of\n"
    "this License, whose permissions for other licensees extend to the\n"
    "entire whole, and thus to each and every part regardless of who wrote\n"
    "it.\n"
    "\n"
    "Thus, it is not the intent of this section to claim rights or contest\n"
    "your rights to work written entirely by you; rather, the intent is to\n"
    "exercise the right to control the distribution of derivative or\n"
    "collective works based on the Library.\n"
    "\n"
    "In addition, mere aggregation of another work not based on the Library\n"
    "with the Library (or with a work based on the Library) on a volume of\n"
    "a storage or distribution medium does not bring the other work under\n"
    "the scope of this License.\n"
    "\n"
    "  3. You may opt to apply the terms of the ordinary GNU General Public\n"
    "License instead of this License to a given copy of the Library.  To do\n"
    "this, you must alter all the notices that refer to this License, so\n"
    "that they refer to the ordinary GNU General Public License, version 2,\n"
    "instead of to this License.  (If a newer version than version 2 of the\n"
    "ordinary GNU General Public License has appeared, then you can specify\n"
    "that version instead if you wish.)  Do not make any other change in\n"
    "these notices.\n"
    "\n"
    "\n"
    "  Once this change is made in a given copy, it is irreversible for\n"
    "that copy, so the ordinary GNU General Public License applies to all\n"
    "subsequent copies and derivative works made from that copy.\n"
    "\n"
    "  This option is useful when you wish to copy part of the code of\n"
    "the Library into a program that is not a library.\n"
    "\n"
    "  4. You may copy and distribute the Library (or a portion or\n"
    "derivative of it, under Section 2) in object code or executable form\n"
    "under the terms of Sections 1 and 2 above provided that you accompany\n"
    "it with the complete corresponding machine-readable source code, which\n"
    "must be distributed under the terms of Sections 1 and 2 above on a\n"
    "medium customarily used for software interchange.\n"
    "\n"
    "  If distribution of object code is made by offering access to copy\n"
    "from a designated place, then offering equivalent access to copy the\n"
    "source code from the same place satisfies the requirement to\n"
    "distribute the source code, even though third parties are not\n"
    "compelled to copy the source along with the object code.\n"
    "\n"
    "  5. A program that contains no derivative of any portion of the\n"
    "Library, but is designed to work with the Library by being compiled or\n"
    "linked with it, is called a \"work that uses the Library\".  Such a\n"
    "work, in isolation, is not a derivative work of the Library, and\n"
    "therefore falls outside the scope of this License.\n"
    "\n"
    "  However, linking a \"work that uses the Library\" with the Library\n"
    "creates an executable that is a derivative of the Library (because it\n"
    "contains portions of the Library), rather than a \"work that uses the\n"
    "library\".  The executable is therefore covered by this License.\n"
    "Section 6 states terms for distribution of such executables.\n"
    "\n"
    "  When a \"work that uses the Library\" uses material from a header file\n"
    "that is part of the Library, the object code for the work may be a\n"
    "derivative work of the Library even though the source code is not.\n"
    "Whether this is true is especially significant if the work can be\n"
    "linked without the Library, or if the work is itself a library.  The\n"
    "threshold for this to be true is not precisely defined by law.\n"
    "\n"
    "  If such an object file uses only numerical parameters, data\n"
    "structure layouts and accessors, and small macros and small inline\n"
    "functions (ten lines or less in length), then the use of the object\n"
    "file is unrestricted, regardless of whether it is legally a derivative\n"
    "work.  (Executables containing this object code plus portions of the\n"
    "Library will still fall under Section 6.)\n"
    "\n"
    "  Otherwise, if the work is a derivative of the Library, you may\n"
    "distribute the object code for the work under the terms of Section 6.\n"
    "Any executables containing that work also fall under Section 6,\n"
    "whether or not they are linked directly with the Library itself.\n"
    "\n"
    "\n"
    "  6. As an exception to the Sections above, you may also combine or\n"
    "link a \"work that uses the Library\" with the Library to produce a\n"
    "work containing portions of the Library, and distribute that work\n"
    "under terms of your choice, provided that the terms permit\n"
    "modification of the work for the customer's own use and reverse\n"
    "engineering for debugging such modifications.\n"
    "\n"
    "  You must give prominent notice with each copy of the work that the\n"
    "Library is used in it and that the Library and its use are covered by\n"
    "this License.  You must supply a copy of this License.  If the work\n"
    "during execution displays copyright notices, you must include the\n"
    "copyright notice for the Library among them, as well as a reference\n"
    "directing the user to the copy of this License.  Also, you must do one\n"
    "of these things:\n"
    "\n"
    "    a) Accompany the work with the complete corresponding\n"
    "    machine-readable source code for the Library including whatever\n"
    "    changes were used in the work (which must be distributed under\n"
    "    Sections 1 and 2 above); and, if the work is an executable linked\n"
    "    with the Library, with the complete machine-readable \"work that\n"
    "    uses the Library\", as object code and/or source code, so that the\n"
    "    user can modify the Library and then relink to produce a modified\n"
    "    executable containing the modified Library.  (It is understood\n"
    "    that the user who changes the contents of definitions files in the\n"
    "    Library will not necessarily be able to recompile the application\n"
    "    to use the modified definitions.)\n"
    "\n"
    "    b) Use a suitable shared library mechanism for linking with the\n"
    "    Library.  A suitable mechanism is one that (1) uses at run time a\n"
    "    copy of the library already present on the user's computer system,\n"
    "    rather than copying library functions into the executable, and (2)\n"
    "    will operate properly with a modified version of the library, if\n"
    "    the user installs one, as long as the modified version is\n"
    "    interface-compatible with the version that the work was made with.\n"
    "\n"
    "    c) Accompany the work with a written offer, valid for at\n"
    "    least three years, to give the same user the materials\n"
    "    specified in Subsection 6a, above, for a charge no more\n"
    "    than the cost of performing this distribution.\n"
    "\n"
    "    d) If distribution of the work is made by offering access to copy\n"
    "    from a designated place, offer equivalent access to copy the above\n"
    "    specified materials from the same place.\n"
    "\n"
    "    e) Verify that the user has already received a copy of these\n"
    "    materials or that you have already sent this user a copy.\n"
    "\n"
    "  For an executable, the required form of the \"work that uses the\n"
    "Library\" must include any data and utility programs needed for\n"
    "reproducing the executable from it.  However, as a special exception,\n"
    "the materials to be distributed need not include anything that is\n"
    "normally distributed (in either source or binary form) with the major\n"
    "components (compiler, kernel, and so on) of the operating system on\n"
    "which the executable runs, unless that component itself accompanies\n"
    "the executable.\n"
    "\n"
    "  It may happen that this requirement contradicts the license\n"
    "restrictions of other proprietary libraries that do not normally\n"
    "accompany the operating system.  Such a contradiction means you cannot\n"
    "use both them and the Library together in an executable that you\n"
    "distribute.\n"
    "\n"
    "\n"
    "  7. You may place library facilities that are a work based on the\n"
    "Library side-by-side in a single library together with other library\n"
    "facilities not covered by this License, and distribute such a combined\n"
    "library, provided that the separate distribution of the work based on\n"
    "the Library and of the other library facilities is otherwise\n"
    "permitted, and provided that you do these two things:\n"
    "\n"
    "    a) Accompany the combined library with a copy of the same work\n"
    "    based on the Library, uncombined with any other library\n"
    "    facilities.  This must be distributed under the terms of the\n"
    "    Sections above.\n"
    "\n"
    "    b) Give prominent notice with the combined library of the fact\n"
    "    that part of it is a work based on the Library, and explaining\n"
    "    where to find the accompanying uncombined form of the same work.\n"
    "\n"
    "  8. You may not copy, modify, sublicense, link with, or distribute\n"
    "the Library except as expressly provided under this License.  Any\n"
    "attempt otherwise to copy, modify, sublicense, link with, or\n"
    "distribute the Library is void, and will automatically terminate your\n"
    "rights under this License.  However, parties who have received copies,\n"
    "or rights, from you under this License will not have their licenses\n"
    "terminated so long as such parties remain in full compliance.\n"
    "\n"
    "  9. You are not required to accept this License, since you have not\n"
    "signed it.  However, nothing else grants you permission to modify or\n"
    "distribute the Library or its derivative works.  These actions are\n"
    "prohibited by law if you do not accept this License.  Therefore, by\n"
    "modifying or distributing the Library (or any work based on the\n"
    "Library), you indicate your acceptance of this License to do so, and\n"
    "all its terms and conditions for copying, distributing or modifying\n"
    "the Library or works based on it.\n"
    "\n"
    "  10. Each time you redistribute the Library (or any work based on the\n"
    "Library), the recipient automatically receives a license from the\n"
    "original licensor to copy, distribute, link with or modify the Library\n"
    "subject to these terms and conditions.  You may not impose any further\n"
    "restrictions on the recipients' exercise of the rights granted herein.\n"
    "You are not responsible for enforcing compliance by third parties with\n"
    "this License.\n"
    "\n"
    "\n"
    "  11. If, as a consequence of a court judgment or allegation of patent\n"
    "infringement or for any other reason (not limited to patent issues),\n"
    "conditions are imposed on you (whether by court order, agreement or\n"
    "otherwise) that contradict the conditions of this License, they do not\n"
    "excuse you from the conditions of this License.  If you cannot\n"
    "distribute so as to satisfy simultaneously your obligations under this\n"
    "License and any other pertinent obligations, then as a consequence you\n"
    "may not distribute the Library at all.  For example, if a patent\n"
    "license would not permit royalty-free redistribution of the Library by\n"
    "all those who receive copies directly or indirectly through you, then\n"
    "the only way you could satisfy both it and this License would be to\n"
    "refrain entirely from distribution of the Library.\n"
    "\n"
    "If any portion of this section is held invalid or unenforceable under any\n"
    "particular circumstance, the balance of the section is intended to apply,\n"
    "and the section as a whole is intended to apply in other circumstances.\n"
    "\n"
    "It is not the purpose of this section to induce you to infringe any\n"
    "patents or other property right claims or to contest validity of any\n"
    "such claims; this section has the sole purpose of protecting the\n"
    "integrity of the free software distribution system which is\n"
    "implemented by public license practices.  Many people have made\n"
    "generous contributions to the wide range of software distributed\n"
    "through that system in reliance on consistent application of that\n"
    "system; it is up to the author/donor to decide if he or she is willing\n"
    "to distribute software through any other system and a licensee cannot\n"
    "impose that choice.\n"
    "\n"
    "This section is intended to make thoroughly clear what is believed to\n"
    "be a consequence of the rest of this License.\n"
    "\n"
    "  12. If the distribution and/or use of the Library is restricted in\n"
    "certain countries either by patents or by copyrighted interfaces, the\n"
    "original copyright holder who places the Library under this License may add\n"
    "an explicit geographical distribution limitation excluding those countries,\n"
    "so that distribution is permitted only in or among countries not thus\n"
    "excluded.  In such case, this License incorporates the limitation as if\n"
    "written in the body of this License.\n"
    "\n"
    "  13. The Free Software Foundation may publish revised and/or new\n"
    "versions of the Lesser General Public License from time to time.\n"
    "Such new versions will be similar in spirit to the present version,\n"
    "but may differ in detail to address new problems or concerns.\n"
    "\n"
    "Each version is given a distinguishing version number.  If the Library\n"
    "specifies a version number of this License which applies to it and\n"
    "\"any later version\", you have the option of following the terms and\n"
    "conditions either of that version or of any later version published by\n"
    "the Free Software Foundation.  If the Library does not specify a\n"
    "license version number, you may choose any version ever published by\n"
    "the Free Software Foundation.\n"
    "\n"
    "\n"
    "  14. If you wish to incorporate parts of the Library into other free\n"
    "programs whose distribution conditions are incompatible with these,\n"
    "write to the author to ask for permission.  For software which is\n"
    "copyrighted by the Free Software Foundation, write to the Free\n"
    "Software Foundation; we sometimes make exceptions for this.  Our\n"
    "decision will be guided by the two goals of preserving the free status\n"
    "of all derivatives of our free software and of promoting the sharing\n"
    "and reuse of software generally.\n"
    "\n"
    "                            NO WARRANTY\n"
    "\n"
    "  15. BECAUSE THE LIBRARY IS LICENSED FREE OF CHARGE, THERE IS NO\n"
    "WARRANTY FOR THE LIBRARY, TO THE EXTENT PERMITTED BY APPLICABLE LAW.\n"
    "EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR\n"
    "OTHER PARTIES PROVIDE THE LIBRARY \"AS IS\" WITHOUT WARRANTY OF ANY\n"
    "KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE\n"
    "IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR\n"
    "PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE\n"
    "LIBRARY IS WITH YOU.  SHOULD THE LIBRARY PROVE DEFECTIVE, YOU ASSUME\n"
    "THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.\n"
    "\n"
    "  16. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN\n"
    "WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY\n"
    "AND/OR REDISTRIBUTE THE LIBRARY AS PERMITTED ABOVE, BE LIABLE TO YOU\n"
    "FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR\n"
    "CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE\n"
    "LIBRARY (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING\n"
    "RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A\n"
    "FAILURE OF THE LIBRARY TO OPERATE WITH ANY OTHER SOFTWARE), EVEN IF\n"
    "SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH\n"
    "DAMAGES.\n"
    "\n"
    "                     END OF TERMS AND CONDITIONS\n"
    "\n"
    "\n"
    "           How to Apply These Terms to Your New Libraries\n"
    "\n"
    "  If you develop a new library, and you want it to be of the greatest\n"
    "possible use to the public, we recommend making it free software that\n"
    "everyone can redistribute and change.  You can do so by permitting\n"
    "redistribution under these terms (or, alternatively, under the terms of the\n"
    "ordinary General Public License).\n"
    "\n"
    "  To apply these terms, attach the following notices to the library.  It is\n"
    "safest to attach them to the start of each source file to most effectively\n"
    "convey the exclusion of warranty; and each file should have at least the\n"
    "\"copyright\" line and a pointer to where the full notice is found.\n"
    "\n"
    "    <one line to give the library's name and a brief idea of what it does.>\n"
    "    Copyright (C) <year>  <name of author>\n"
    "\n"
    "    This library is free software; you can redistribute it and/or\n"
    "    modify it under the terms of the GNU Lesser General Public\n"
    "    License as published by the Free Software Foundation; either\n"
    "    version 2.1 of the License, or (at your option) any later version.\n"
    "\n"
    "    This library is distributed in the hope that it will be useful,\n"
    "    but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
    "    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n"
    "    Lesser General Public License for more details.\n"
    "\n"
    "    You should have received a copy of the GNU Lesser General Public\n"
    "    License along with this library; if not, write to the Free Software\n"
    "    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA\n"
    "\n"
    "Also add information on how to contact you by electronic and paper mail.\n"
    "\n"
    "You should also get your employer (if you work as a programmer) or your\n"
    "school, if any, to sign a \"copyright disclaimer\" for the library, if\n"
    "necessary.  Here is a sample; alter the names:\n"
    "\n"
    "  Yoyodyne, Inc., hereby disclaims all copyright interest in the\n"
    "  library `Frob' (a library for tweaking knobs) written by James Random Hacker.\n"
    "\n"
    "  <signature of Ty Coon>, 1 April 1990\n"
    "  Ty Coon, President of Vice\n"
    "\n"
    "That's all there is to it!\n"
    "\n";
  _info_print(lgpl_2_1_license);
}

inline void print_lgpl_3_license()
{
  const char* lgpl_3_license =
    "\n"
    "                   GNU LESSER GENERAL PUBLIC LICENSE\n"
    "                       Version 3, 29 June 2007\n"
    "\n"
    " Copyright (C) 2007 Free Software Foundation, Inc. <https://fsf.org/>\n"
    " Everyone is permitted to copy and distribute verbatim copies\n"
    " of this license document, but changing it is not allowed.\n"
    "\n"
    "\n"
    "  This version of the GNU Lesser General Public License incorporates\n"
    "the terms and conditions of version 3 of the GNU General Public\n"
    "License, supplemented by the additional permissions listed below.\n"
    "\n"
    "  0. Additional Definitions.\n"
    "\n"
    "  As used herein, \"this License\" refers to version 3 of the GNU Lesser\n"
    "General Public License, and the \"GNU GPL\" refers to version 3 of the GNU\n"
    "General Public License.\n"
    "\n"
    "  \"The Library\" refers to a covered work governed by this License,\n"
    "other than an Application or a Combined Work as defined below.\n"
    "\n"
    "  An \"Application\" is any work that makes use of an interface provided\n"
    "by the Library, but which is not otherwise based on the Library.\n"
    "Defining a subclass of a class defined by the Library is deemed a mode\n"
    "of using an interface provided by the Library.\n"
    "\n"
    "  A \"Combined Work\" is a work produced by combining or linking an\n"
    "Application with the Library.  The particular version of the Library\n"
    "with which the Combined Work was made is also called the \"Linked\n"
    "Version\".\n"
    "\n"
    "  The \"Minimal Corresponding Source\" for a Combined Work means the\n"
    "Corresponding Source for the Combined Work, excluding any source code\n"
    "for portions of the Combined Work that, considered in isolation, are\n"
    "based on the Application, and not on the Linked Version.\n"
    "\n"
    "  The \"Corresponding Application Code\" for a Combined Work means the\n"
    "object code and/or source code for the Application, including any data\n"
    "and utility programs needed for reproducing the Combined Work from the\n"
    "Application, but excluding the System Libraries of the Combined Work.\n"
    "\n"
    "  1. Exception to Section 3 of the GNU GPL.\n"
    "\n"
    "  You may convey a covered work under sections 3 and 4 of this License\n"
    "without being bound by section 3 of the GNU GPL.\n"
    "\n"
    "  2. Conveying Modified Versions.\n"
    "\n"
    "  If you modify a copy of the Library, and, in your modifications, a\n"
    "facility refers to a function or data to be supplied by an Application\n"
    "that uses the facility (other than as an argument passed when the\n"
    "facility is invoked), then you may convey a copy of the modified\n"
    "version:\n"
    "\n"
    "   a) under this License, provided that you make a good faith effort to\n"
    "   ensure that, in the event an Application does not supply the\n"
    "   function or data, the facility still operates, and performs\n"
    "   whatever part of its purpose remains meaningful, or\n"
    "\n"
    "   b) under the GNU GPL, with none of the additional permissions of\n"
    "   this License applicable to that copy.\n"
    "\n"
    "  3. Object Code Incorporating Material from Library Header Files.\n"
    "\n"
    "  The object code form of an Application may incorporate material from\n"
    "a header file that is part of the Library.  You may convey such object\n"
    "code under terms of your choice, provided that, if the incorporated\n"
    "material is not limited to numerical parameters, data structure\n"
    "layouts and accessors, or small macros, inline functions and templates\n"
    "(ten or fewer lines in length), you do both of the following:\n"
    "\n"
    "   a) Give prominent notice with each copy of the object code that the\n"
    "   Library is used in it and that the Library and its use are\n"
    "   covered by this License.\n"
    "\n"
    "   b) Accompany the object code with a copy of the GNU GPL and this license\n"
    "   document.\n"
    "\n"
    "  4. Combined Works.\n"
    "\n"
    "  You may convey a Combined Work under terms of your choice that,\n"
    "taken together, effectively do not restrict modification of the\n"
    "portions of the Library contained in the Combined Work and reverse\n"
    "engineering for debugging such modifications, if you also do each of\n"
    "the following:\n"
    "\n"
    "   a) Give prominent notice with each copy of the Combined Work that\n"
    "   the Library is used in it and that the Library and its use are\n"
    "   covered by this License.\n"
    "\n"
    "   b) Accompany the Combined Work with a copy of the GNU GPL and this license\n"
    "   document.\n"
    "\n"
    "   c) For a Combined Work that displays copyright notices during\n"
    "   execution, include the copyright notice for the Library among\n"
    "   these notices, as well as a reference directing the user to the\n"
    "   copies of the GNU GPL and this license document.\n"
    "\n"
    "   d) Do one of the following:\n"
    "\n"
    "       0) Convey the Minimal Corresponding Source under the terms of this\n"
    "       License, and the Corresponding Application Code in a form\n"
    "       suitable for, and under terms that permit, the user to\n"
    "       recombine or relink the Application with a modified version of\n"
    "       the Linked Version to produce a modified Combined Work, in the\n"
    "       manner specified by section 6 of the GNU GPL for conveying\n"
    "       Corresponding Source.\n"
    "\n"
    "       1) Use a suitable shared library mechanism for linking with the\n"
    "       Library.  A suitable mechanism is one that (a) uses at run time\n"
    "       a copy of the Library already present on the user's computer\n"
    "       system, and (b) will operate properly with a modified version\n"
    "       of the Library that is interface-compatible with the Linked\n"
    "       Version.\n"
    "\n"
    "   e) Provide Installation Information, but only if you would otherwise\n"
    "   be required to provide such information under section 6 of the\n"
    "   GNU GPL, and only to the extent that such information is\n"
    "   necessary to install and execute a modified version of the\n"
    "   Combined Work produced by recombining or relinking the\n"
    "   Application with a modified version of the Linked Version. (If\n"
    "   you use option 4d0, the Installation Information must accompany\n"
    "   the Minimal Corresponding Source and Corresponding Application\n"
    "   Code. If you use option 4d1, you must provide the Installation\n"
    "   Information in the manner specified by section 6 of the GNU GPL\n"
    "   for conveying Corresponding Source.)\n"
    "\n"
    "  5. Combined Libraries.\n"
    "\n"
    "  You may place library facilities that are a work based on the\n"
    "Library side by side in a single library together with other library\n"
    "facilities that are not Applications and are not covered by this\n"
    "License, and convey such a combined library under terms of your\n"
    "choice, if you do both of the following:\n"
    "\n"
    "   a) Accompany the combined library with a copy of the same work based\n"
    "   on the Library, uncombined with any other library facilities,\n"
    "   conveyed under the terms of this License.\n"
    "\n"
    "   b) Give prominent notice with the combined library that part of it\n"
    "   is a work based on the Library, and explaining where to find the\n"
    "   accompanying uncombined form of the same work.\n"
    "\n"
    "  6. Revised Versions of the GNU Lesser General Public License.\n"
    "\n"
    "  The Free Software Foundation may publish revised and/or new versions\n"
    "of the GNU Lesser General Public License from time to time. Such new\n"
    "versions will be similar in spirit to the present version, but may\n"
    "differ in detail to address new problems or concerns.\n"
    "\n"
    "  Each version is given a distinguishing version number. If the\n"
    "Library as you received it specifies that a certain numbered version\n"
    "of the GNU Lesser General Public License \"or any later version\"\n"
    "applies to it, you have the option of following the terms and\n"
    "conditions either of that published version or of any later version\n"
    "published by the Free Software Foundation. If the Library as you\n"
    "received it does not specify a version number of the GNU Lesser\n"
    "General Public License, you may choose any version of the GNU Lesser\n"
    "General Public License ever published by the Free Software Foundation.\n"
    "\n"
    "  If the Library as you received it specifies that a proxy can decide\n"
    "whether future versions of the GNU Lesser General Public License shall\n"
    "apply, that proxy's public statement of acceptance of any version is\n"
    "permanent authorization for you to choose that version for the\n"
    "Library.\n"
    "\n";
  _info_print(lgpl_3_license);
}

inline void print_boost_license()
{
  const char* boost_license =
    "\n"
    "Boost Software License - Version 1.0 - August 17th, 2003\n"
    "\n"
    "Permission is hereby granted, free of charge, to any person or organization\n"
    "obtaining a copy of the software and accompanying documentation covered by\n"
    "this license (the \"Software\") to use, reproduce, display, distribute,\n"
    "execute, and transmit the Software, and to prepare derivative works of the\n"
    "Software, and to permit third-parties to whom the Software is furnished to\n"
    "do so, all subject to the following:\n"
    "\n"
    "The copyright notices in the Software and this entire statement, including\n"
    "the above license grant, this restriction and the following disclaimer,\n"
    "must be included in all copies of the Software, in whole or in part, and\n"
    "all derivative works of the Software, unless such copies or derivative\n"
    "works are solely in the form of machine-executable object code generated by\n"
    "a source language processor.\n"
    "\n"
    "THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
    "IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
    "FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT\n"
    "SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE\n"
    "FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,\n"
    "ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER\n"
    "DEALINGS IN THE SOFTWARE.\n"
    "\n";
  _info_print(boost_license);
}

#endif // PRINT_LICENSE_H_

